import UIKit
import Flutter
import BankConnect
import SwiftUI

public class FinBoxViewController: UIViewController {
    
    var bankResultCallback : ((FinBoxPayload) -> Void)
    
    init(bankResultCallback: @escaping (FinBoxPayload) -> Void) {
        // Initialize BankResult
        self.bankResultCallback = bankResultCallback
        
        super.init(nibName: nil, bundle: nil)
    }
    
    required init?(coder decoder: NSCoder) {
        fatalError("init(coder:) is not supported")
    }

    public override func viewDidLoad() {
        debugPrint("View Controller Loaded")
        
        // BankConnect Swift UI element
        let swiftUIView = BankView() {
            payload in
            // Send the data back to the flutter plugin
            self.bankResultCallback(payload)
            // Close the view
            self.dismiss(animated: true)
        }
        
        // Handles the Swift UI elements on UI Kit
        let child = UIHostingController(rootView: swiftUIView)
        // Set the bounds
        child.view.frame = view.bounds
        
        // Add the child to the view
        self.view.addSubview(child.view)
    }
}
